##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

"""Wrapper that returns a PageTemplate.
$Id: FormWrapper.py,v 1.2 2001/08/09 19:51:51 jack Exp $
"""
__version__='$Revision: 1.2 $'[11:-2]


from Acquisition import aq_inner, aq_parent
import Globals
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import ManagePortal

from string import join

from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

class FormWrapper(ZopePageTemplate):
	''' a wrapper-class to let the form behave like a pagetemplate '''
	
	######## BAD PARAMETER !!!! RELEATED IN FORMSCOLLECTION render_form ...
	
	def __init__(self,home,obj,form,template,view,scripts,REQUEST=None):

		errors = {}
		if REQUEST is not None:
		    err = REQUEST.get('validation_errors',None)
		    if err is not None:
			for e in err['errors']:
			    errors[e.field_id] = e.error_text
		    

		txt = []
		a = txt.append
		a('<html>')
		a(' <body>')
		a('  <div metal:define-macro="form" tal:define="home here/portal_forms/%s; form home/forms/%s">\n' % (home.getId(),form.getId()))
		a('   <div metal:use-macro="home/templates/%s/macros/%s">' % (template,view))
		for group in form.get_groups():
		
		    ## if group has only one element don't display a table !!!! NOT IMPLEMENTED
		    a('     <table border="0" metal:fill-slot="%s">' % group)
		    for field in form.get_fields_in_group(group):

			if not errors.has_key(field.getId()):
			    label_style = 'class="label"'
			    description = field.get_value('description')
			else:
			    label_style = 'class="label_with_error"'
			    description = errors.get(field.getId())

			if not errors:
			    widget = field.render_from_object(object=obj,REQUEST=REQUEST)
			else:			    
			    widget = field.render_from_request(REQUEST)

			a('   <tr>')
		        a('    <td valign="top" nowrap %s >%s</td><td>%s<br>%s</td>' % (label_style,field.get_value('title'),widget,description))
			a('   </tr>')
		    if group == 'Default':
		        a('   <input type="hidden" name="portal_forms_name" value="%s"/>' % form.getId())
		        a('   <input type="hidden" name="portal_forms_view" value="%s"/>' % view)
		    a('    </table>')

		if len(scripts) > 0:
		    ## default buttons
		    a('     <table border="0" metal:fill-slot="Buttons">')
		    a('      <tr>')
		    for script in scripts:
		        scriptobj = home.getScript(script)
		        a('    <td valign="top"><input type="submit" name="%s:method" value="%s"/></td>' % (script,scriptobj.title))
		    a('      </tr>')
		    a('    </table>')


		a('   </div>')
		a('  </div>')
		a(' </body>')
		a('</html>\n')
		
		text = join(txt,'\n')
		
		ZopePageTemplate.__init__(self,'Form',text,'text/html') 
